Subject: Re: [PATCH net-next 1/6] docs: add more netlink docs (incl. spec docs)

From: Guillaume Nault <[email-masked]>
Date: Thu, 29 Sep 2022 17:11:45 +0200

On Thu, Sep 29, 2022 at 07:32:24AM -0700, Jakub Kicinski wrote:
> On Thu, 29 Sep 2022 15:34:13 +0200 Guillaume Nault wrote:
> > > +Make sure to pass the request info to genl_notify() to allow ``NLM_F_ECHO``
> > > +to take effect.  
> > 
> > Do you mean that netlink commands should properly handle NLM_F_ECHO,
> > although they should also design their API so that users don't need it?
> 
> Yes, ECHO should be supported but as an extra, not something that
> is crucial to write a basic script without assuming full ownership 
> of the system...
> 
> IOW support the logging use case you mentioned but don't do the NEWLINK
> thing.
> 
> Should I clarify or rephrase? The ECHO section needs to be read with
> the one above it to get the full answer.

Maybe we can make this more explicit.
Something like:

-Having to rely on ``NLM_F_ECHO`` is a hack, not a valid design.
+Users shouldn't have to use ``NLM_F_ECHO`` to get a handle on the created
+object.

(or keep both sentences, I feel they fit well together).

Then maybe explain in the next section why support for NLM_F_ECHO is
desirable anyway:

 Make sure to pass the request info to genl_notify() to allow ``NLM_F_ECHO``
-to take effect.
+to take effect. This is usefull for programs that need precise feedback from
+ the kernel (for example for logging purpose).